#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <alloc.h>
#include <time.h>
#include <dos.h>
#include "graphics.h"

#define pause() if (getch() == 0) getch();

byte far *double_buffer;
paletteType defaultpal;

void pattern(void);
void palette_test(void);
void image_test(void);
void shadow_text(int x, int y, char *string);

int main(void)
{
  // Sets up 320x200 256 color VGA mode
  setvmode(0x13);

  // Allocates 64000 byte double buffer
  double_buffer = (byte far *)farmalloc(64000L);
  if (double_buffer == NULL)          // If not enough memory, leave program
  {
    setvmode(0x3);
    cprintf("Error: Not enough memory");
    return 1;
  }

  pattern();
  palette_test();
  image_test();

  // Returns to text mode
  farfree(double_buffer);
  setvmode(0x3);
  return 0;
}

void pattern(void)
{
  int x, y;
  for (x = 0; x < 320; x++)     // Draws a nifty little pattern on the screen
    for (y = 0; y < 200; y++)
      pixel(x, y) = x ^ y;

  shadow_text(0, 0, "Pixel() Test");
  pause();

  shadow_text(0, 8, "Saving Image...");

  saveScreen("pattern.img");
  pause();

  randomize();
  for (x = 0; x < 320; x++)
    for (y = 0; y < 200; y++)
      pixel(x, y) = random(256);

  shadow_text(0, 0, "Image Thrashed! :( Load the backup!");
  pause();

  loadScreen("pattern.img");
  shadow_text(0, 16, "It worked!");
  pause();
}

void palette_test(void)
{
  int x, y;
  for (x = 0; x < 320; x++)
    for (y = 0; y < 200; y++)
      pixel(x, y) = x * y;

  shadow_text(0, 0, "FadeOut()");
  pause();
  getAllPalette(defaultpal);
  fadeOut(defaultpal);
  pause();
  shadow_text(0, 8, "FadeIn()");
  fadeIn(defaultpal);
  shadow_text(0, 16, "FadeTo()");

  paletteType reverse;

  // Generates a reverse palette;
  int i;
  for (i = 0; i < 256; i++)
  {
    reverse[i].red   = 63 - defaultpal[i].red;
    reverse[i].green = 63 - defaultpal[i].green;
    reverse[i].blue  = 63 - defaultpal[i].blue; 
  }

  // Fades from and to the new palette
  pause();
  fadeTo(defaultpal, reverse);
  pause();
  fadeTo(reverse, defaultpal);
  pause();
}

void image_test(void)
{
  imageType square;
  allocImage(40, 40, &square);
  if (square.ptr == NULL) return;
  grabImage(40, 40, &square);
  clearScreen();

  shadow_text(0, 0, "Image Test");
  pause();

  int x, y;
  while (!kbhit())
  {
    blitImage(random(320 - 40), random(200 - 40), &square);
    delay(10);
  }

  pause();
  pause();

  resetImage(&square);
}

void shadow_text(int x, int y, char *string)
{
  clearArea(x, y, strlen(string) * 8, 8);
  blitString(x, y, 15, string);
}
