// GETSCAN.CPP
// Keyboard Scan Code Retriever
//
// Chad Austin
// 4-25-97
//
// I wrote this utility to find the scan codes of the keys I was going to use
// in my game.  It was written for Borland C++ 5.0, although it should
// compile under any C/C++ compiler.  I have only tested it in the medium
// memory model.  It may work under some others.
//
// bcc getscan keyboard.lib
//

// Includes

#include <conio.h>         // For console output
#include "keyboard.h"      // Keyboard library header

void main(void)
{
  byte done;

  initKeyboard();          // Initializes new keyboard handler
  clrscr();
  cputs("Press any key...\n\r");         // Prompts user for key

  while (!done)                          // Waits until a key is pressed
  {
    int x;
    for (x = 0; x < 128; x++)
      if (keyTable[x] && x != 42)   // If a key is pressed, exits and prints
      {                             // that code.  42 is the code for all
                                    // special keys, so it is discarded.
        cprintf("Scan code: %d\n\r", x);
        done = 1;
        break;
      }
  }

  closeKeyboard();         // Resets keyboard handler
}
