#define byte unsigned char          // Byte data type


// Key which has been pressed most recently.  If a key has just been let go
// of, rawKey == (scancode + 128), else rawKey == (scancode).

extern volatile byte rawKey;


// Table of keys currently pressed

extern volatile byte keyTable[128];


// Initializes keyboard.  NEVER call this twice in a row.  You may, however,
// call initKeyboard(), then call closeKeyboard(), then initKeyboard() again.

#ifdef __cplusplus
extern "C"
{
#endif

extern void initKeyboard(void);


// Resets keyboard.  ONLY call this after initKeyboard().  Always call this
// before exiting the program.

extern void closeKeyboard(void);


// Returns 1 if a key is pressed, 0 if no key is pressed.

extern byte keyPressed(void);

// Pauses program until a key is pressed.  This may not work exactly as
// planned.  It is recommended that you make your own pause routine and
// handle the keys your own way.

extern void pause(void);

#ifdef __cplusplus
}
#endif

// Some definitions of common keys.  Use GETSCAN to get the scancode of a
// key.

#define UPARROW    72
#define DOWNARROW  80
#define LEFTARROW  75
#define RIGHTARROW 77
#define ENTER      28
#define ESC        1
#define SPACEBAR   57      
