#include <stdio.h>
#include <alloc.h>
#include "pcx.h"

int  PCX_Init(PCX_PICTURE *image)
{
  image->buffer = (unsigned char far *)farmalloc(64000L + 1);
  if (image->buffer == NULL) return 1;
  return 0;
}

void PCX_Close(PCX_PICTURE *image)
{
  farfree(image->buffer);
}

int  PCX_Load(char *filename, PCX_PICTURE *image)
{
  FILE *fp;
  int num_bytes, index;
  long count;
  int data;

  fp = fopen(filename, "rb");
  if (fp == NULL)
    return 1;

  fread(&image->header, 1, 128, fp);

  count = 0;
  while (count <= 64000)
  {
    data = fgetc(fp);

    if (data >= 192 && data <= 255)
    {
      num_bytes = data - 192;
      data = fgetc(fp);

      while(num_bytes-- > 0)
        image->buffer[count++] = data;
    }
    else
      image->buffer[count++] = data;
  }

  fseek(fp, -768L, SEEK_END);

  for (index = 0; index < 256; index++)
  {
    image->palette[index].red   = (fgetc(fp) >> 2);
    image->palette[index].green = (fgetc(fp) >> 2);
    image->palette[index].blue  = (fgetc(fp) >> 2);
  }

  fclose(fp);

  return 0;
}

