typedef struct RGB_TAG
{
  unsigned char red;
  unsigned char green;
  unsigned char blue;
} RGB;

typedef struct PCX_HEADER_TAG
{
  char manufacturer;
  char version;
  char encoding;
  char bits_per_pixel;
  int  x, y;
  int  width, height;
  int  horz_res;
  int  vert_res;
  char ega_palette[48];
  char reserved;
  char num_color_planes;
  int  bytes_per_line;
  int  palette_type;
  char padding[58];
} PCX_HEADER;

typedef struct PCX_PICTURE_TAG
{
  PCX_HEADER header;
  RGB palette[256];
  unsigned char far *buffer;
} PCX_PICTURE;

#ifdef __cplusplus
extern "C"
{
#endif

extern int  PCX_Init(PCX_PICTURE *image);
extern void PCX_Close(PCX_PICTURE *image);
extern int  PCX_Load(char *filename, PCX_PICTURE *image);

#ifdef __cplusplus
}
#endif
